> This page is for APIs, version Calculations.
> For other versions, use one of these documentation indexes:
> - Overview (default): https://avalara.ferndocs.com/api-reference/overview/llms.txt
> - Calculations: https://avalara.ferndocs.com/api-reference/calculations/llms.txt
> - E-invoicing: https://avalara.ferndocs.com/api-reference/e-invoicing/llms.txt
> - Brazil: https://avalara.ferndocs.com/api-reference/brazil/llms.txt
> - Returns: https://avalara.ferndocs.com/api-reference/returns/llms.txt
> - Shared service: https://avalara.ferndocs.com/api-reference/shared-service/llms.txt
> - 1099 & W-9: https://avalara.ferndocs.com/api-reference/1099-w9/llms.txt
> - Tax registrations & business licenses: https://avalara.ferndocs.com/api-reference/tax-registrations/llms.txt
> - ECM: https://avalara.ferndocs.com/api-reference/ecm/llms.txt
> - Cross-Border: https://avalara.ferndocs.com/api-reference/cross-border/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://avalara.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://avalara.ferndocs.com/_mcp/server.

# List Recommended Parameter By Company Id And Item Id

GET https://rest.avatax.com/api/v2/definitions/companies/{companyId}/items/{itemId}/parameters

> **Access control:** this endpoint is available to users with the `everyone` role.

Returns the list of parameters based on the company's service types and the item code.
Ignores nexus if a service type is configured in the 'IgnoreNexusForServiceTypes' configuration section.
Ignores nexus for the AvaAlcohol service type.

### Security Policies

* This API requires one of the following user roles: AccountAdmin, AccountOperator, AccountUser, AvaTaxOnlyAccountAdmin, AvaTaxOnlyAccountUser, AvaTaxOnlyCompanyAdmin, AvaTaxOnlyCompanyUser, BatchServiceAdmin, CompanyAdmin, CompanyUser, CSPAdmin, CSPTester, ReturnsOnlyAccountAdmin, ReturnsOnlyAccountUser, ReturnsOnlyCompanyAdmin, ReturnsOnlyCompanyUser, SiteAdmin, SSTAdmin, SystemAdmin, TechnicalSupportAdmin, TechnicalSupportUser.


Reference: https://avalara.ferndocs.com/api-reference/calculations/ava-tax/public-reference/list-recommended-parameter-by-company-id-and-item-id

## Authentication

- `Authorization` header (required) — API Key authentication via header

## Request

### Path parameters

- `companyId` (integer, required) — Company Identifier.
- `itemId` (long, required) — Item Identifier.

### Query parameters

- `$filter` (string, optional) — A filter statement to identify specific records to retrieve. For more information on filtering, see [Filtering in REST](http://developer.avalara.com/avatax/filtering-in-rest/).*Not filterable:* serviceTypes, regularExpression, attributeSubType, values
- `$top` (integer, optional) — If nonzero, return no more than this number of results. Used with `$skip` to provide pagination for large datasets. Unless otherwise specified, the maximum number of records that can be returned from an API call is 1,000 records.
- `$skip` (integer, optional) — If nonzero, skip this number of results before returning data. Used with `$top` to provide pagination for large datasets.
- `$orderBy` (string, optional) — A comma separated list of sort statements in the format `(fieldname) [ASC|DESC]`, for example `id ASC`.

### Headers

- `X-Avalara-Client` (string, optional, default: Swagger UI; 26.7.0; Custom; 1.0) — Identifies the software you are using to call this API. For more information on the client header, see [Client Headers](https://developer.avalara.com/avatax/client-headers/) .

## Response

### 200

Success

- `@recordsetCount` (integer, optional)
- `value` (list of ParameterModel, optional)
- `@nextLink` (string, optional)
- `pageKey` (string, optional)

## Types

### ParameterModel

An extra property that can change the behavior of tax transactions.

- `id` (long, optional) — The unique ID number of this property.
- `category` (string, optional) — DEPRECATED - Date: 07/25/2018, Version: 18.7, Message: This field is deprecated and will return null. The category grouping of this parameter. When your user interface displays a large number of parameters, they should be grouped by their category value.
- `name` (string, optional) — The name of the property. To use this property, add a field on the `parameters` object of a [CreateTransaction](https://developer.avalara.com/api-reference/avatax/rest/v2/methods/Transactions/CreateTransaction/) call.
- `dataType` (string, optional) — The data type of the property.
- `helpText` (string, optional) — Help text to be shown to the user when they are filling out this parameter. Help text may include HTML links to additional content with more information about a parameter.
- `serviceTypes` (list of string, optional) — A list of service types to which this parameter applies.
- `prompt` (string, optional) — DEPRECATED - Date: 07/25/2018, Version: 18.7, Message: This field is deprecated and will return null. The prompt you should use when displaying this parameter to a user. For example, if your user interface displays a parameter in a text box, this is the label you should use to identify that text box.
- `regularExpression` (string, optional) — DEPRECATED - Date: 07/25/2018, Version: 18.7, Message: This field is deprecated and will return null. If your user interface permits client-side validation of parameters, this string is a regular expression you can use to validate the user's data entry prior to submitting a tax request.
- `label` (string, optional) — Label that helps the user to identify a parameter
- `helpUrl` (string, optional) — A help url that provides more information about the parameter
- `attributeType` (string, optional) — The type of parameter as determined by its application, e.g. Product, Transaction, Calculated
- `attributeSubType` (string, optional) — The sub-type of parameter as determined by its application.
- `values` (list of string, optional) — If the parameter is of enumeration data type, then this list will be populated with all of the possible enumeration values.
- `measurementType` (string, optional) — The unit of measurement type of the parameter
- `isNeededForCalculation` (boolean, optional) — This field identifies if parameter is needed for calculation
- `isNeededForReturns` (boolean, optional) — This field identifies if parameter is needed for returns
- `isNeededForClassification` (boolean, optional) — This field identifies if parameter is needed for classification

## Examples

**Response**

```json
{
  "@recordsetCount": 1,
  "value": [
    {
      "id": 12345,
      "category": "Lodging",
      "name": "NumberOfNights",
      "dataType": "NumericMeasured",
      "helpText": "Please enter the number of nights the customer stayed in your lodging; whole numbers only.",
      "serviceTypes": [
        "AvaLodging"
      ],
      "prompt": "Lodging Number of Nights",
      "regularExpression": "\\d*",
      "label": "lodging",
      "helpUrl": "www.example.com/lodging",
      "attributeType": "string",
      "attributeSubType": "string",
      "values": [
        "string"
      ],
      "measurementType": "string",
      "isNeededForCalculation": true,
      "isNeededForReturns": false,
      "isNeededForClassification": false
    }
  ],
  "@nextLink": "string",
  "pageKey": "string"
}
```

**SDK Code**

```python
import requests

url = "https://rest.avatax.com/api/v2/definitions/companies/1/items/1/parameters"

headers = {"Authorization": "<apiKey>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://rest.avatax.com/api/v2/definitions/companies/1/items/1/parameters';
const options = {method: 'GET', headers: {Authorization: '<apiKey>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.avatax.com/api/v2/definitions/companies/1/items/1/parameters"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://rest.avatax.com/api/v2/definitions/companies/1/items/1/parameters")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.avatax.com/api/v2/definitions/companies/1/items/1/parameters")
  .header("Authorization", "<apiKey>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.avatax.com/api/v2/definitions/companies/1/items/1/parameters', [
  'headers' => [
    'Authorization' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://rest.avatax.com/api/v2/definitions/companies/1/items/1/parameters");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "<apiKey>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.avatax.com/api/v2/definitions/companies/1/items/1/parameters")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```